/** 页数*/
var pageNumber = 0; 
/** 最后一层div距离页面顶端的长度*/
var divTop = 0; 
/** 每一层div 的高度*/
divHeight = 0; 
/** 标示符，第一次启动是0*/
var h = 0; 
/** 是否启动夜间模式*/
var isNight;
/** 滚动事件时间间隔判断，如果间隔时间小于0.3秒则忽略，否则计入事件行列*/
var timebefore=new Date().getTime();
/**记录修改字体以前滚动条在页面中的位置*/
var percent=0;
/**当前阅读的页面距离底部的div总数*/
var bottomDivs=0;
/**同步两次append完成以后再append的参数1 控制有效滚动事件促发的次数*/
var scrollg=0;
/**同步两次append完成以后再append的参数2 控制有效append的次数*/
var appenda=0;
/**同步两次append完成以后再append的参数2 控制从onload添加的内容*/
var isOnload=0;
/**
 * 获取高度，判断是否需要append
 * @return h 高度，供方法isAppend()使用
 */
function getHeight(){
    var bottomEl = document.getElementById("bottom"); // 最底端的元素
    var contentDiv = bottomEl.previousSibling; //上上个元素
    divHeight = contentDiv.offsetHeight; // 插入的层的高度
    divTop = contentDiv.offsetTop; // 插入的层距离顶点的高度
    var contextHeight = document.body.scrollHeight; // 网页全文高度
    var scrollTop = document.body.scrollTop; // 滚动条高度
    var h = scrollTop - divTop + divHeight; // 判断的数值，如果小于XX，则再次append
    return h;
}

/**
 * append内容
 * @param content 要添加的内容
 * @return append的总页数
 */
function appendContent(content){
    pageNumber++;
	appenda++;
    var contentDiv = document.createElement("div");
    contentDiv.setAttribute('class', 'page');
    var contentText = document.createElement("div");
    contentText.setAttribute("class","pagecontent");
    // contentText.setAttribute("class","border3");
    //var hr = document.createElement("hr");
    var separator = document.createElement("img");
    if(isNight==1){
    	separator.setAttribute('src', 'file:///android_asset/image/reading_separator_night.png');
    }else{
    	separator.setAttribute('src', 'file:///android_asset/image/reading_separator.png');
    }
    separator.style.width = '100%';
    separator.style.height = '24px';
	//hr.style.borderTop ="1px dotted";
	//hr.style.height="0";
    contentText.innerHTML = content;
    contentDiv.appendChild(contentText);
    //contentDiv.appendChild(hr);
    contentDiv.appendChild(separator);
    var bottomEl = document.getElementById("bottom");
    bottomEl.parentNode.insertBefore(contentDiv, bottomEl);
    //return pageNumber;
	if(isOnload=1){
    	scrollg=appenda;
    }
	console.error("pageNumber:"+pageNumber);
	if(pageNumber==1){
		remove_loading();
		setTimeout("displayLast()",1000);
//		setTimeout("hideLast()",3000);
	}

	window.readmodel.updateScreen();
}

/**
 * 结束Loading
 */
function remove_loading(){
	var loadingDiv = document.getElementById("loading");
	try{
		document.body.removeChild(loadingDiv);
	}catch(e){
		console.log('the loading div is null!');
	}
}

/**
 * 判断是否需要append
 * @return 0或1 1为需要append，0不需要
 */
function isAppend(){
    var bool = 0;
    if (h == 0) {
        h = -1;
        bool = 1;//需要
    }
    else {
        h = getHeight();
        if (h > 0 && h < divHeight) { //预备在倒数第二页时加载数据
            bool = 1;
        }
    }
    return bool;
}
/**
 * 判断滚动条是否在底部
 * @return
 */
function isBottom(){
	var isbottom=0;
	var gunTop=document.body.scrollTop;//滚动条离顶部距离
	var gunHeight=document.body.scrollHeight;//全局高度
	var client=document.body.clientHeight;//可见区域
//	var bottomdiv=document.getElementById("bottom");
//	var bottomTop=bottomdiv.offsetTop;
//	var bottomHeight=bottomdiv.offsetHeight;
//	var relativeTop=bottomTop+bottomHeight;
//	console.info("client+gunTop:"+client+"  "+gunTop+" gunHeight:"+gunHeight+" relativeTop:"+relativeTop);
	var value=client+gunTop;
	var bottomdivheight=document.getElementById("bottom").previousSibling.offsetHeight;
	if(value<=gunHeight&&value>gunHeight-bottomdivheight){
		isbottom=1;
	}
	return isbottom;
}
/**
 * 滚动一个屏幕的内容，预留50px
 * 如果是在上半屏，传入'up'否则传入'down'
 * @return
 */
function scrollScreen(updown){
	var gunTop=document.body.scrollTop;//滚动条离顶部距离
	var client=document.body.clientHeight;//可见区域
	if(updown=='up'){
		window.scrollBy(0,gunTop-client+50);
	}else{
		window.scrollBy(0,gunTop+client-50);
	}
	
}
/**
 * 计算当前页面显示的内容距离最底部相差几个div
 */
function getCurrentDiv(){
	var gunTop=document.body.scrollTop;//滚动条离顶部距离
	var gunHeight=document.body.scrollHeight;//全局高度
	var bottomHeight=document.getElementById("bottom").offsetHeight;//底部等待状态高
	var height=gunHeight-gunTop;//相差的长度
	var lastDiv=document.getElementById("bottom").previousSibling;
	var lastDivHeight=lastDiv.offsetHeight;//div的高度
    var n = 0;
	var temp=lastDiv.previousSibling;
	var divHeights=temp.offsetHeight;//下方所有div的高度的总和
    if (lastDivHeight >= height) {
        n = 1;
    }
    else {
        while (true) {
        	temp=temp.previousSibling;
			n++;
			var oldDivHeights=divHeights;
			divHeights+=temp.offsetHeight;
			if(oldDivHeights<=height&&divHeights>height){
				break;
			}
			
        }
    }
	bottomDivs=n;
	console.info("bottomDivs:"+bottomDivs);
//	var n=height/divHeight;
//	bottomDivs=Math.round(n);//n取大的整数部分
//	console.info("n:"+Math.round(n));
//	percent=gunTop/(gunHeight-bottomHeight);
//	console.info("getCurrentDiv:"+percent+" gunHeight:"+gunHeight);
}
/**
 * 滚动条滚动到百分比，java的onResume时调用该方法
 * @param percent
 * @return
 */
function scrollToPercent(){
	console.info("scrollToPercent():bottomDivs:"+bottomDivs);
	var gunHeight=document.body.scrollHeight;//全局高度
	var bottomDiv=document.getElementById("bottom");
	var nowdiv=bottomDiv.previousSibling;
	for(var i=1;i<bottomDivs;i++){
		nowdiv=nowdiv.previousSibling
	}
	var y=gunHeight-nowdiv.offsetTop;
	window.scrollTo(0,y);
	
//	var gunHeight=document.body.scrollHeight;//全局高度
//	var bottomHeight=document.getElementById("bottom").offsetHeight;//底部等待状态高
//	var afterscroll=(gunHeight-bottomHeight)*percent+bottomHeight;
//	console.info("scrollToPercent:"+afterscroll+" gunHeight:"+gunHeight);
//	window.scrollTo(0,afterscroll);
}
/**
 * 隐藏页面最底部的等待图标，当页面为小说的最后一页时调用
 */
function hideLast(){
    var bottomEl = document.getElementById("bottom"); // 最底部的元素
    bottomEl.style.display = 'none';
    bottomEl.style.visibility = 'hidden';
    console.error("hideLast");
}
/**
 * 显示页面最底部的等待图标，初始化完毕时调用
 */
function displayLast(){
    var bottomEl = document.getElementById("bottom"); // 最底部的元素
    bottomEl.style.display = 'block';
    bottomEl.style.visibility = 'visible';
    console.error("displayLast");
}

/**
 * 页面加载事件
 */
window.onload = function(){
//        window.readmodel.scroll("onload", pageNumber + 1);
	isOnload=1;
	//去掉页面加载时触发预读动作，在onpageFinished中已经做了预读。
//		window.readmodel.addAppendTasks();
//		remove_loading();
//		setTimeout("displayLast()",1000);//1秒钟以后显示底部等待状态图片
//		setTimeout("setTextSize('little')",5000);
//		setTimeout("setNightMode('true')",5000);
} 
/**
 * 窗口重置大小事件
 */
window.onresize = function(){
    if (isAppend() == 1) {
    }
}

/**
 * 滚动条滚动事件
 */
window.onscroll = _onscroll;
function _onscroll(){
	//页面到底部触发事件
	if(forceEmit()==1){
		window.readmodel.addAppendTasks();
	}
	else if (isAppend() == 1 || isBottom() == '1') {
		var ti = new Date().getTime();
		console.info("timebefore:" + timebefore + " - " + ti + " = " + (ti - timebefore));
		if (ti - timebefore > 300) {
			if(scrollg==appenda){
				console.error("timebefore:" + (ti - timebefore));
    			isOnload=0;
    			window.readmodel.addAppendTasks();
    			scrollg=scrollg+2;
    		}
		}
		timebefore = new Date().getTime();
		//    getCurrentDiv();
	}
}
function setResumeScroll(){
	window.onscroll = _onscroll;
}
/**
 * 页面onResume时调用
 */
function onResume(){
	console.info("onResume()");
	setTimeout("setResumeScroll()",3000); 
}
/**
 * 点击菜单键的事件
 */
function onMenu(){
	console.info("onMenu()");
	window.onscroll = null;
}
/**
 * 设置是否是夜间模式
 * @param str 1/0
 */
function setIsNight(str){
	isNight=str;
	if(isNight=='1'){
		setNightMode('true');
	}else{
		setNightMode('false');
	}
}
/**
 * 更改分割线的背景
 * @param oldimage
 * @param newimage
 */
function changeSeparator(oldimage, newimage) {
    var list=document.getElementsByTagName("img");
    for (var i=0; i<list.length; ++i) {
      if (list[i] && list[i].getAttribute("src")!=null
        && list[i].getAttribute("src").indexOf(oldimage)!=-1)
      {
    	  list[i].setAttribute("src", newimage);
      }
    }
  }
/**
 * 设置文本的大小
 * @param size normal/large/little
 */
function setSize(size){
    var cssRules = document.styleSheets[0].cssRules;
    if (size == 'normal'){
	      cssRules[1].style.fontSize = '19px';
	      cssRules[1].style.lineHeight = '24px';
	      cssRules[2].style.fontSize = '23px';
	      cssRules[2].style.lineHeight = '25px';
	  }
	  else if (size == 'large'){
	      cssRules[1].style.fontSize = '22px';
	      cssRules[1].style.lineHeight = '27px';
	      cssRules[2].style.fontSize = '26px';
	      cssRules[2].style.lineHeight = '28px';
	  } 
	  else if(size=='little'){
	  	  cssRules[1].style.fontSize = '16px';
	      cssRules[1].style.lineHeight = '21px';
	      cssRules[2].style.fontSize = '20px';
	      cssRules[2].style.lineHeight = '22px';
	  }
}
/**
 * 设置夜间模式效果
 * @param enabled true/false
 */
function setNightMode(enabled){
    var cssRules = document.styleSheets[0].cssRules;
    if (enabled == 'true'){
		  cssRules[0].style.background = '#222222';
	      cssRules[1].style.background = '#222222';
	      cssRules[1].style.color = '#999999';
	      cssRules[2].style.background = '#222222';
	      cssRules[2].style.color = '#999999';
	      cssRules[3].style.background = '#222222';
	      cssRules[3].style.color = '#999999';
	      changeSeparator('file:///android_asset/image/reading_separator.png', 'file:///android_asset/image/reading_separator_night.png');
	      isNight=1;
	  }
	  else{
	      cssRules[0].style.background = '#eeeeee';
	      cssRules[1].style.background = '#eeeeee';
	      cssRules[1].style.color = '#333333';
	      cssRules[2].style.background = '#eeeeee';
	      cssRules[2].style.color = '#000000';
	      cssRules[3].style.background = '#eeeeee';
	      cssRules[3].style.color = '#333333';
	      changeSeparator('file:///android_asset/image/reading_separator_night.png', 'file:///android_asset/image/reading_separator.png');
	      isNight=0;
	  }
	  }
/**
 * 设置联网错误时页面的提示信息
 * @param message
 * @return
 */
function setErrorPage(){
	var loading_div=document.getElementById("loading");
	if(loading_div){
		loading_div.style.display = 'none';
		loading_div.style.visibility = 'hidden';
	}
}

/**
 * 取窗口滚动条高度
 */

function getScrollTop() {
	var scrollTop = 0;
	if (document.documentElement && document.documentElement.scrollTop) {
		scrollTop = document.documentElement.scrollTop;
	} else if (document.body) {
		scrollTop = document.body.scrollTop;
	}
	return scrollTop;
}
/**
 * 取窗口可视范围的高度
 */

function getClientHeight() {
	var clientHeight = 0;
	if (document.body.clientHeight && document.documentElement.clientHeight) {
		var clientHeight = (document.body.clientHeight < document.documentElement.clientHeight) ? document.body.clientHeight
				: document.documentElement.clientHeight;
	} else {
		var clientHeight = (document.body.clientHeight > document.documentElement.clientHeight) ? document.body.clientHeight
				: document.documentElement.clientHeight;
	}
	return clientHeight;
}
/**
 * 取文档内容实际高度
 */
function getScrollHeight() {
	return Math.max(document.body.scrollHeight,
			document.documentElement.scrollHeight);
}
/**
 * 强制滚动到底部触发事件
 * 
 * @return
 */
function forceEmit() {
	var force = 0;
	if (getScrollTop() + getClientHeight() == getScrollHeight()) {
		force = 1;
	} else {
		force = 0;
	}
	//console.error("forceEmit:getScrollTop(),getClientHeight(),getScrollHeight()"+getScrollTop()+","+getClientHeight()+","+getScrollHeight()+","+force);
	return force;
}